user/dev discussion of public-inbox itself
 help / color / mirror / code / Atom feed
* [PATCH] learn: implement "rm" only functionality
@ 2017-01-19  0:34 Eric Wong
  0 siblings, 0 replies; only message in thread
From: Eric Wong @ 2017-01-19  0:34 UTC (permalink / raw)
  To: meta

Do not consider this interface stable, but I just needed a
way to remove mis-imported multipart messages so
public-inbox-watch could pick them up again from my Maildir.
---
 script/public-inbox-learn | 25 ++++++++++++++-----------
 1 file changed, 14 insertions(+), 11 deletions(-)

diff --git a/script/public-inbox-learn b/script/public-inbox-learn
index a696d34..38c8324 100755
--- a/script/public-inbox-learn
+++ b/script/public-inbox-learn
@@ -16,7 +16,7 @@ $Email::MIME::ContentType::STRICT_PARAMS = 0; # user input is imperfect
 use PublicInbox::Address;
 use PublicInbox::Spamcheck::Spamc;
 my $train = shift or die "usage: $usage\n";
-if ($train !~ /\A(?:ham|spam)\z/) {
+if ($train !~ /\A(?:ham|spam|rm)\z/) {
 	die "`$train' not recognized.\nusage: $usage\n";
 }
 
@@ -27,15 +27,18 @@ my $mime = PublicInbox::MIME->new(eval {
 	local $/;
 	my $data = scalar <STDIN>;
 	$data =~ s/\A[\r\n]*From [^\r\n]*\r?\n//s;
-	eval {
-		if ($train eq 'ham') {
-			$spamc->hamlearn(\$data);
-		} else {
-			$spamc->spamlearn(\$data);
-		}
-		die "spamc failed with: $?\n" if $?;
-	};
-	$err = $@;
+
+	if ($train ne 'rm') {
+		eval {
+			if ($train eq 'ham') {
+				$spamc->hamlearn(\$data);
+			} elsif ($train eq 'spam') {
+				$spamc->spamlearn(\$data);
+			}
+			die "spamc failed with: $?\n" if $?;
+		};
+		$err = $@;
+	}
 	$data
 });
 
@@ -61,7 +64,7 @@ foreach my $recipient (keys %dests) {
 	my $email = $ENV{GIT_COMMITTER_EMAIL} || $recipient;
 	my $im = PublicInbox::Import->new($git, $name, $email);
 
-	if ($train eq "spam") {
+	if ($train eq "spam" || $train eq "rm") {
 		# This needs to be idempotent, as my inotify trainer
 		# may train for each cross-posted message, and this
 		# script already learns for every list in
-- 
EW


^ permalink raw reply related	[flat|nested] only message in thread

only message in thread, other threads:[~2017-01-19  0:34 UTC | newest]

Thread overview: (only message) (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2017-01-19  0:34 [PATCH] learn: implement "rm" only functionality Eric Wong

Code repositories for project(s) associated with this public inbox

	https://80x24.org/public-inbox.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).